<template>
  <CForm
    class="user-search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="name"
          type="text"
          label="Name"
          :disabled="loading"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'user-tie']" class="width-1x" />
          </template>
        </CInput>
      </div>
      <div class="col-12 col-xl-6">
        <CInput
          v-model="email"
          type="text"
          label="Email"
          :disabled="loading"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'envelope']" class="width-1x" />
          </template>
        </CInput>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="phone"
          type="text"
          label="Phone"
          :disabled="loading"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'phone']" class="width-1x" />
          </template>
        </CInput>
      </div>
      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            Status
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group
              v-model="status"
              :list="[]"
              :name="'status'"
            />
          </CCol>
        </div>
      </div>
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="disabled || loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        Search
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        Clear
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  .user-search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>

<script>
import { isEqual } from 'lodash'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SUBMIT = 'submit'

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      // Form search
      name: null,
      email: null,
      phone: null,
      status: null,

      // Previous codition
      prevCondition: null
    }
  },

  computed: {
    /**
     * Check disable status of button search
     *
     * @return {Boolean} Disable status of button search
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }

      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Get condition input on form
     *
     * @return {Object} Condition
     */
    condition () {
      const condition = {}

      if (this.name) {
        condition.name = this.name
      }

      if (this.email) {
        condition.email = this.email
      }

      if (this.phone) {
        condition.phone = this.phone
      }

      return condition
    }
  },

  methods: {
    /**
     * Clean all condition data on form
     */
    onClearFormSearch () {
      this.name = null
      this.email = null
      this.phone = null
      this.status = null
    },

    /**
     * Check validate input
     * If valid then show error
     * Else call submit event
     */
    onSubmit () {
      this.prevCondition = this.condition
      this.$emit(EVENT_SUBMIT, this.condition)
    }
  }
}
</script>
